# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  ########
##############################################################################

from os.path import join, dirname, realpath, exists, expanduser
from gi.repository import Gtk
import daw_config, daw_customs
from os import mkdir
import sqlite3

PATH0 = dirname(dirname(realpath(__file__))).decode('utf8')
PATH1 = join(u'usr', u'share', u'dawawin')
PATH2 = join(u'usr', u'local', u'share', u'dawawin')

if exists(join(PATH0, u'asmaa-data', u'icons', u'greet.png')):
    PATH = PATH0
    
elif exists(join(PATH1, u'asmaa-data', u'icons', u'greet.png')):
    PATH = PATH1
    
elif exists(join(PATH2, u'asmaa-data', u'icons', u'greet.png')):
    PATH = PATH2

if exists(join(PATH1, u'dawawin-arab', u'Data', u'Dawawin.db')):
    LIBRARY_DIR_r   = join(PATH1, u'dawawin-arab')
    DATA_DIR_r      = join(LIBRARY_DIR_r, u'Data')
    AUDIO_DIR_r     = join(LIBRARY_DIR_r, u'Audio')
    DATA_FILE_r = join(LIBRARY_DIR_r, u'Data', u'Dawawin.db')
else:
    LIBRARY_DIR_r   = u''
    BOOK_DIR_r      = u''
    DATA_DIR_r      = u''
    INDEX_DIR_r     = u''
    LISTBOOK_FILE_r = u''

APP_DIR       =   PATH0
HOME_DIR      =   expanduser(u'~/.asmaa')
ASMAA_DIR     =   join(PATH, u'asmaa-data')
ICON_DIR      =   join(ASMAA_DIR, u'icons')
DB_DIR        =   join(ASMAA_DIR, u'db')
QURAN_DB      =   join(DB_DIR, u'Quran.db')
TAFSIR_DB     =   join(DB_DIR, u'Tafsir.db')
AUTHOR_DB     =   join(DB_DIR, u'Author.db')
DALIL_DB      =   join(DB_DIR, u'Dalil.db')
MOEJAM_DB     =   join(DB_DIR, u'Moejam.db')
TARAJIM_DB    =   join(DB_DIR, u'Tarajim.db')
MOSHAF_DIR    =   join(ASMAA_DIR, u'moshaf')


LIBRARY_DIR_rw = join(HOME_DIR, u'asmaa-library')

if daw_config.getv('path') != join(LIBRARY_DIR_rw, u'data', u'Listbooks.db'): 
    if not exists(daw_config.getv('path')): 
        res = daw_customs.sure_start()
        if res == Gtk.ResponseType.YES:
            daw_customs.change_path_db()
            library_path  = daw_config.getv('path')
            LIBRARY_DIR_rw = dirname(dirname(library_path)).decode('utf8')
        elif res == Gtk.ResponseType.NO:
            my_return = 0
            quit()
        elif res == 3:
            save_dlg = Gtk.FileChooserDialog(u'مسار قاعدة البيانات الجديدة', None,
                                        Gtk.FileChooserAction.SELECT_FOLDER,
                                        (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                        Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
            res = save_dlg.run()
            if res == Gtk.ResponseType.OK:
                new_dir = join(save_dlg.get_filename().decode('utf8'), u'مكتبة أسماء')
                if exists(join(new_dir, u'data', u'Listbooks.db')):
                    daw_customs.erro(None, u'يوجد مكتبة في هذا الدليل بالفعل')
                else:
                    if not exists(new_dir):
                        mkdir(new_dir)
                    if not exists(join(new_dir, u'data')):
                        mkdir(join(new_dir, u'data'))
                    if not exists(join(new_dir, u'books')):
                        mkdir(join(new_dir, u'books'))
                    if not exists(join(new_dir, u'index')):
                        mkdir(join(new_dir, u'index'))
                    con = sqlite3.connect(join(new_dir, u'data', u'Listbooks.db'))
                    cur = con.cursor()
                    cur.execute('CREATE TABLE groups (id_group integer primary key, \
                    tit varchar(255), sub INTEGER, cat INTEGER)') 
                    cur.execute('CREATE TABLE books (id_book integer primary key, tit varchar(255), \
                    parent INTEGER, fav  INTEGER DEFAULT 0, last  INTEGER DEFAULT 1, cat  INTEGER DEFAULT 0,\
                    tafsir  INTEGER DEFAULT 0, indx INTEGER DEFAULT 0)')
                    daw_customs.info(None, u'تم إضافة مكتبة مفرغة جديدة')
            save_dlg.destroy()
            daw_config.setv('path', join(new_dir, u'data', u'Listbooks.db'))
            library_path  = daw_config.getv('path')
            LIBRARY_DIR_rw = dirname(dirname(library_path)).decode('utf8')
    else:
        library_path = daw_config.getv('path')
        LIBRARY_DIR_rw = dirname(dirname(library_path)).decode('utf8')
    
BOOK_DIR_rw      =   join(LIBRARY_DIR_rw, u'books')
DATA_DIR_rw      =   join(LIBRARY_DIR_rw, u'data')
INDEX_DIR_rw     =   join(LIBRARY_DIR_rw, u'index') 
LISTBOOK_FILE_rw =   join(LIBRARY_DIR_rw, u'data', u'Listbooks.db')  
    
# a إصلاحات------------------------------------------
    
if not exists(join(LIBRARY_DIR_rw, u'books')):
    mkdir(join(LIBRARY_DIR_rw, u'books'))
    
if not exists(join(LIBRARY_DIR_rw, u'index')):
    mkdir(join(LIBRARY_DIR_rw, u'index'))

if not exists(join(LIBRARY_DIR_rw, u'fields-search')):
    mkdir(join(LIBRARY_DIR_rw, u'fields-search'))
    
if not exists(join(LIBRARY_DIR_rw, u'waraka-search')):
    mkdir(join(LIBRARY_DIR_rw, u'waraka-search'))
    