# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join, dirname, exists
import os
from shutil import copyfile
from daw_contacts import MyDB
from gi.repository import Gtk
import daw_config, daw_customs



# class نافذة التفضيلات----------------------------------------------------------       
        
class Preference(Gtk.Dialog):
    
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        self.build()        
        
    def specified(self, *a):
        if self.dfo.get_active():
            self.frame.set_sensitive(False)
            daw_config.setv('tr', '0')
        elif self.sug.get_active():
            self.frame.set_sensitive(False)
            daw_config.setv('tr', '1')
        else:
            self.frame.set_sensitive(True)
            daw_config.setv('tr', '2')
        
    def ch_font(self, btn):
        nconf = btn.get_name()
        dialog = Gtk.FontChooserDialog("اختر خطا")
        dialog.set_font(daw_config.getv(nconf))
        response = dialog.run()
        if response == Gtk.ResponseType.OK:
            font = dialog.get_font()
            daw_config.setv(nconf, font)
        dialog.destroy()
        self.parent.theme.refrech()
        
#FIXME change 'get_current_color' to 'get_current_rgba'-------------
    def ch_color(self, btn):
        nconf = btn.get_name()
        dialog = Gtk.ColorSelectionDialog("اختر لونا")
        colorsel = dialog.get_color_selection()
        colorsel.set_current_rgba(daw_customs.rgba(daw_config.getv(nconf)))
        response = dialog.run()
        if response == Gtk.ResponseType.OK:
            color = colorsel.get_current_color().to_string()
            daw_config.setv(nconf, color)
        dialog.destroy()
        self.parent.theme.refrech()
    
    def change_vls(self, btn, nm):
        v = btn.get_active()
        daw_config.setv(nm, v)
   
    def change_path_db(self, *a):
        open_dlg = Gtk.FileChooserDialog(u'تغيير مسار قاعدة البيانات',
                                         self.parent, Gtk.FileChooserAction.OPEN,
                                        (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                         Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        
        Filter = Gtk.FileFilter()
        Filter.set_name(u"قاعدة البيانات")
        Filter.add_pattern("Dawawin.db")
        open_dlg.add_filter(Filter)
        
        res = open_dlg.run()
        if res == Gtk.ResponseType.OK:
            self.e_dest.set_text(open_dlg.get_filenames()[0].decode('utf8')) 
            daw_config.setv('path', open_dlg.get_filenames()[0])          
        open_dlg.destroy()
    
    def new_db(self,*a): 
        save_dlg = Gtk.FileChooserDialog(u'مسار قاعدة البيانات الجديدة', self.parent,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        res = save_dlg.run()
        if res == Gtk.ResponseType.OK:
            new_dir = join(save_dlg.get_filename().decode('utf8'), u'دواوين العرب')
            if os.path.exists(join(new_dir,'Dawawin.db')):
                daw_customs.erro(self.parent, u'يوجد قاعدة بيانات في هذا الدليل بالفعل')
            else:
                if not os.path.exists(new_dir):
                    os.mkdir(new_dir)
                if not os.path.exists(join(new_dir,u'Audio')):
                    os.mkdir(join(new_dir,u'Audio'))
                if not os.path.exists(join(new_dir,u'Ornament')):
                    os.mkdir(join(new_dir,u'Ornament'))
                list_f = os.listdir(daw_customs.ORNAMENT)
                for v in list_f:
                    copyfile(join(daw_customs.ORNAMENT,v), join(new_dir,u'Ornament',v))
                self.parent.db.create_db(join(new_dir,'Dawawin.db'))
                copyfile(daw_customs.MY_AWZAN, join(new_dir,'Awzan.db'))
                copyfile(daw_customs.MY_HELP, join(new_dir,'Help.db'))
                copyfile(daw_customs.MY_DICT, join(new_dir,'Dict.db'))
                daw_customs.info(self.parent, u'تم إضافة قاعدة بيانات جديدة')
        save_dlg.destroy()
 
    def modify_all(self, *a):
        self.parent.main_notebook.set_current_page(16) 
        self.hide()
             
    def build(self,*a):
        Gtk.Dialog.__init__(self, parent=self.parent)
        self.set_icon_name("Dawawin")
        self.set_title("التفضيلات")
        self.resize(500, 300)
        area = self.get_content_area()
        area.set_spacing(6)
        self.connect('delete-event', lambda w,*a: w.hide() or True)
        self.box = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        
        self.notebook = Gtk.Notebook()
        self.box0 = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        self.box00 = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        self.box1 = Gtk.Box(spacing=4, orientation=Gtk.Orientation.VERTICAL)
        self.box2 = Gtk.Box(spacing=4,orientation=Gtk.Orientation.VERTICAL)
        hbox = Gtk.Box(spacing=40,orientation=Gtk.Orientation.HORIZONTAL)
        hbox.pack_start(self.box1, False, False, 0)
        hbox.pack_start(self.box2, False, False, 0)
        self.frame = Gtk.Frame()
        self.frame.add(hbox)
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        self.dfo = Gtk.RadioButton.new_with_label_from_widget(None, 'افتراضي')
        self.sug = Gtk.RadioButton.new_with_label_from_widget(self.dfo,'مقترح')
        self.cos = Gtk.RadioButton.new_with_label_from_widget(self.dfo,'مخصص')
        self.dfo.connect('toggled',self.specified,'0')
        self.sug.connect('toggled',self.specified,'1')
        self.cos.connect('toggled',self.specified,'1')
        hbox.pack_start(self.dfo, False, False, 0)
        hbox.pack_start(self.sug, False, False, 0)
        hbox.pack_start(self.cos, False, False, 0)
        
        btn_font = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_FONT)
        btn_font.set_name('fontall')
        btn_font.connect('clicked',self.ch_font)
        hbox.pack_end(btn_font, False, False, 0)
        hbox.pack_end(Gtk.Label('خط النافذة'), False, False, 0)
        
        hbox.set_border_width(5)
        self.box0.pack_start(hbox, False, False, 0)
        self.box0.pack_start(self.frame, True, True, 0)
       
        list_w1 = [[u'القوائم الجانبية','td'], [u'قائمة القصائد','tp'], [u'متن القصيدة','mp'], 
                   [u'الشرح والترجمة','ch'], [u'العناوين','an']]
        list_w2 = [[u'لون خلفية العرض','b'], [u'لون خط التحديد','fs'], [u'لون خلفية التحديد','bs'], 
                   [u'لون تحديد البحث','ss'], [u'لون خلفية خاص','bp']]
        for a in list_w1:
            hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
            btn1 = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_FONT)
            btn1.set_name('font'+a[1])
            btn1.connect('clicked',self.ch_font)
            btn2 = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_COLOR)
            btn2.set_name('color'+a[1])
            btn2.connect('clicked',self.ch_color)
            hbox.pack_start(btn2, False, False, 0)
            hbox.pack_start(btn1, False, False, 0)
            hbox.pack_start(Gtk.Label(a[0]), False, False, 0)
            self.box1.pack_start(hbox, False, False, 0)
            
        for a in list_w2:
            hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
            btn = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_COLOR)
            btn.set_name('color'+a[1])
            btn.connect('clicked',self.ch_color)
            hbox.pack_start(btn, False, False, 0)
            hbox.pack_start(Gtk.Label(a[0]), False, False, 0)
            self.box2.pack_start(hbox, False, False, 0)
        self.notebook.append_page(self.box0, Gtk.Label('خط ولون'))
        
        vb = Gtk.VBox(False, 6)
        vb.set_border_width(6)
        ls = [[0, u'ضيق'],
            [1, u'وسط'],
            [2, u'واسع']]
        hb, self.bayn_abiat = daw_customs.combo(ls, u'المسافة بين الأبيات', 3)
        self.bayn_abiat.set_active(daw_config.getn('b_abiat'))
        self.bayn_abiat.connect('changed', self.change_vls, u'b_abiat')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, u'ضيق'],
            [1, u'وسط'],
            [2, u'واسع']]
        hb, self.bayn_shater = daw_customs.combo(ls, u'المسافة بين شطري البيت', 3)
        self.bayn_shater.set_active(daw_config.getn('b_half'))
        self.bayn_shater.connect('changed', self.change_vls, u'b_half')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, u'دوما'],
            [1, u'للحاجة']]
        hb, self.tarakeb = daw_customs.combo(ls, u'تراكب شطري البيت', 3)
        self.tarakeb.set_active(daw_config.getn('tarakeb'))
        self.tarakeb.connect('changed', self.change_vls, u'tarakeb')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, u'بالتطويلات'],
            [1, u'بالمسافات']]
        hb, self.tandhid = daw_customs.combo(ls, u'تعديل طول الشطر', 3)
        self.tandhid.set_active(daw_config.getn('tandhid'))
        self.tandhid.connect('changed', self.change_vls, u'tandhid')
        vb.pack_start(hb, False, False, 0)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        lab = Gtk.Label('أدنى طول للشطر بالبكسلات')
        lab.set_alignment(0,0.5)
        hbox.pack_start(lab, False, False, 0)
        adj = Gtk.Adjustment(150, 100, 700, 1, 5, 0)
        self.min_long = Gtk.SpinButton()
        self.min_long.set_adjustment(adj)
        self.min_long.set_wrap(True)
        self.min_long.set_value(daw_config.getf('min_long'))
        def change_min(widget, *a):
            v = self.min_long.get_value()
            daw_config.setv('min_long', v)
        self.min_long.connect('value-changed', change_min)
        hbox.pack_start(self.min_long, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        lab = Gtk.Label('التراكب إذا تجاوز طول الشطر')
        lab.set_alignment(0,0.5)
        hbox.pack_start(lab, False, False, 0)
        adj = Gtk.Adjustment(350, 300, 1000, 1, 5, 0)
        self.max_long = Gtk.SpinButton()
        self.max_long.set_adjustment(adj)
        self.max_long.set_wrap(True)
        self.max_long.set_value(daw_config.getf('max_long'))
        def change_max(widget, *a):
            v = self.max_long.get_value()
            daw_config.setv('max_long', v)
        self.max_long.connect('value-changed', change_max)
        hbox.pack_start(self.max_long, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        self.notebook.append_page(vb, Gtk.Label('تخطيط'))
        
        vb = Gtk.VBox(False, 6)
        vb.set_border_width(6)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        modif_all = daw_customs.ButtonClass('تعديلات عامة')
        modif_all.connect('clicked',self.modify_all)
        hbox.pack_start(modif_all, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        self.add_db = daw_customs.ButtonClass('إنشاء قاعدة بيانات جديدة')
        self.add_db.connect('clicked', self.new_db)
        hbox.pack_start(self.add_db, False, False, 0)
        if not exists(dirname(daw_config.getv('path'))): self.add_db.set_sensitive(False)
        vb.pack_start(hbox, False, False, 0)
        
        hbox = Gtk.Box(spacing=6,orientation=Gtk.Orientation.HORIZONTAL)
        self.e_dest = Gtk.Entry()
        self.e_dest.set_text(daw_config.getv('path').decode('utf8'))
        self.b_dest = daw_customs.ButtonClass('تغيير المسار')
        self.b_dest.connect('clicked', self.change_path_db)  
        hbox.pack_start(self.b_dest, False, False, 0)
        hbox.pack_start(self.e_dest, True, True, 0)
        vb.pack_start(hbox, False, False, 0)
        
        hbox = Gtk.Box(spacing=11,orientation=Gtk.Orientation.HORIZONTAL)
        db_void = Gtk.LinkButton.new_with_label("http://sourceforge.net/projects/dawawin/files/",
                                                'صفحة البرنامج على النت')
        hbox.pack_start(db_void, False, False, 0)
        
        src_prog = Gtk.LinkButton.new_with_label("https://github.com/RaaH/dawawin",
                                                'مصدر البرنامج على النت')
        hbox.pack_start(src_prog, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        self.notebook.append_page(vb, Gtk.Label('خيارات'))
        
        self.box.pack_start(self.notebook, True, True, 0)
        
        clo = daw_customs.ButtonClass("إغلاق")
        clo.connect('clicked',lambda *a: self.hide())
        ref = daw_customs.ButtonClass("تحديث الواجهة")
        ref.connect('clicked',lambda *a: self.parent.theme.refrech())
        ref.connect('clicked',lambda *a: self.parent.refrech())
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        hbox.set_border_width(5)
        hbox.pack_start(ref, False, False, 0)
        hbox.pack_end(clo, False, False, 0)
        self.box.pack_start(hbox, False, False, 0)
        if daw_config.getv('tr') == '0':
            self.dfo.set_active(True)
            self.frame.set_sensitive(False)
        elif daw_config.getv('tr') == '1':
            self.sug.set_active(True)
            self.frame.set_sensitive(False)
        else:
            self.cos.set_active(True)
        area.pack_start(self.box, True, True, 0)