# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from os.path import join, exists
from os import mkdir, remove
from shutil import copyfile
from gi.repository import Gtk, Pango
from daw_viewer import ShowPoem
import daw_customs

# class القصائد المقروءة-------------------------------------------------------------------

class RecitePoem(Gtk.HPaned):
    
    def export_recite_cb(self, *a):
        model, i = self.tree_recited.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i,0)
            file_media = join(daw_customs.AUDIO_DIR,'00'+str(id_poem)+'.ogg')
            if not exists(file_media): 
                daw_customs.erro(self.parent, u'لا يوجد ملف صوتي لهذه القصيدة')
                return
            save_dlg = Gtk.FileChooserDialog("اختر المجلد الذي تريد التصدير إليه", self.parent,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
            res = save_dlg.run()
            if res == Gtk.ResponseType.OK:
                nm_poem = (self.parent.db.name_poem(id_poem)+u'، إلقاء : {}'.format(model.get_value(i,2).decode('utf8'))).strip()
                if not exists(join(save_dlg.get_filename(), nm_poem.encode('utf-8'))):
                    try:  mkdir(join(save_dlg.get_filename(), nm_poem))
                    except: raise
                dir_save = join(save_dlg.get_filename(), nm_poem, nm_poem+u'.ogg')
                copyfile(file_media, dir_save)
            save_dlg.destroy()
    
    def remove_one(self, *a):
        model, i = self.tree_recited.get_selection().get_selected()
        if i:
            msg = daw_customs.sure(self.parent, "هل تريد مسح الملف الصوتي للقصيدة المحددة")
            if msg == Gtk.ResponseType.YES:
                id_poem = model.get_value(i,0)
                file_media = join(daw_customs.AUDIO_DIR,'00'+str(id_poem)+'.ogg')
                if exists(file_media): 
                    remove(file_media)
                self.parent.db.remove_recite_one(id_poem)
                self.store_recited.remove(i)
    
    def show_poem(self, *a):
        self.player.stop()
        model, i = self.tree_recited.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i,0)
            self.iv.loading(id_poem, self.parent.theme.fontmp)
            self.player.set_sensitive(True)
            file_media = join(daw_customs.AUDIO_DIR,'00'+str(id_poem)+'.ogg')
            self.player.set_media(file_media)
            if not exists(file_media): daw_customs.erro(self.parent, u'لا يوجد ملف صوتي لهذه القصيدة')
            
    def show_info(self, *a):
        model, i = self.sel_recited.get_selected()
        if i:
            self.view_info_bfr.set_text(u'إلقاء : {}'.format(model.get_value(i,2).decode('utf8'),))
    
    def store(self, *a):
        self.store_recited.clear()
        ls = self.parent.db.recited_poems()
        map(self.store_recited.append, ls)
    
    def search_on_page(self, text):
        self.iv.search_on_poem(text) 
    
    def near_page(self, v):
        self.iv.near_poem(v) 
    
    def move_in_page(self, v):
        model, i = self.tree_recited.get_selection().get_selected()
        if i:
            p = model.get_path(i).get_indices()[0]
            if p+v == -1 or p+v == len(model): return
            i1 = model.get_iter((p+v,))
            self.tree_recited.get_selection().select_iter(i1)
            self.tree_recited.scroll_to_cell((p+v,))
        elif len(self.tree_recited.get_model()) == 0: return
        else:
            i2 = model.get_iter((0,))
            self.tree_recited.get_selection().select_iter(i2)
            self.tree_recited.scroll_to_cell((0,))
        self.show_poem()
    
    def __init__(self, parent):
        self.parent = parent
        Gtk.HPaned.__init__(self)
        self.set_position(200)
        vbox = Gtk.Box(spacing=6,orientation=Gtk.Orientation.VERTICAL)
        self.vbox1= Gtk.Box(spacing=6,orientation=Gtk.Orientation.VERTICAL)
        self.tree_recited = daw_customs.TreeClass()
        self.sel_recited = self.tree_recited.get_selection()
        cell = Gtk.CellRendererText()
        cell.set_property("wrap-mode", Pango.WrapMode.WORD_CHAR)
        self.tree_recited.set_size_request(200, -1)
        kal = Gtk.TreeViewColumn('القصائد المقروءة', cell, text=1)
        self.tree_recited.append_column(kal)
        self.store_recited = Gtk.ListStore(int, str, str)
        self.store()
        self.tree_recited.set_model(self.store_recited)
        self.tree_recited.connect("cursor-changed", self.show_info)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_recited)
        scroll.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
        vbox.pack_start(scroll, True, True, 0)
        
        self.view_info = daw_customs.ViewClass()
        self.view_info.set_right_margin(5)
        self.view_info.set_left_margin(5)
        self.view_info_bfr = self.view_info.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_info)
        scroll.set_size_request(-1, 50)
        vbox.pack_start(scroll, False, False, 0)
        
        remove = Gtk.Button("حذف")
        remove.connect('clicked', self.remove_one)
        hbox = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hbox.pack_start(remove, True, True, 0)
        export_recite = Gtk.Button("تصدير")
        export_recite.set_tooltip_text('تصدير الملف الصوتي')
        export_recite.connect('clicked', self.export_recite_cb)
        hbox.pack_start(export_recite, True, True, 0)
        vbox.pack_start(hbox, False, False, 0)
        
        self.iv = ShowPoem(self.parent)
        self.vbox1.show_all()
        self.pack1(vbox, False, False)
        self.pack2(self.vbox1, True, False)
        
        try:
            from daw_player import Mawso3aPlayer
            self.tree_recited.connect("row-activated", self.show_poem)
            self.player = Mawso3aPlayer()
            self.vbox1.pack_start(self.iv, True, True, 0)
            self.iv.pack_end(self.player, False, False, 0)
            self.player.set_sensitive(False)
        except:
            self.vbox1.pack_start(Gtk.Label('تأكد من تثبيت الحزمة : gir1.2-gstreamer-0.10'), True, True, 0)
        self.show_all()
