# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Pango
from daw_contacts import MyDB
from os.path import join
import os
import daw_customs, daw_tools,daw_config

# class صفحة التسلية-------------------------------------------------------------------    

class Repair(Gtk.Notebook):
    
    def search_on_page(self, text):
        return
    
    def move_in_page(self, v):
        return
    
    def near_page(self, v):
        return
    
    def remove_cb(self, *a):
        msg = daw_customs.sure(self.parent, "هل تريد مسح جميع البيانات المعلمة")
        if msg == Gtk.ResponseType.YES:
            for btn in self.list_ages_btn:
                if btn.get_active() :
                    self.set_sensitive(False)
                    self.db.remove_age(int(btn.get_name()))
                    btn.set_active(False)
            if self.del_abiaty.get_active():
                self.db.remove_abiaty()
                self.del_abiaty.set_active(False)
            if self.del_favory.get_active():
                self.db.remove_favory()
                self.del_favory.set_active(False)
            if self.del_recite.get_active():
                self.db.remove_recite()
                self.del_recite.set_active(False)
            if self.del_search.get_active():
                list_n = os.listdir(daw_customs.HOME_DIR)
                for v in list_n:
                    if '.pkl' in v:
                        os.remove(join(daw_customs.HOME_DIR, v))
                self.del_search.set_active(False)
            if self.del_mark.get_active():
                daw_config.setv('marks', '[]')
                self.del_mark.set_active(False)
        self.parent.dawawinpage.refresh_poets()
        self.parent.dawawinpage.search_cb()
        self.parent.organizepage.refresh_poets()
        self.parent.organizepage.search_cb()
        self.parent.favorite.store()
        self.parent.recite.store()
        self.set_sensitive(True)
    
    def modify_langer(self, *a):
        msg = daw_customs.sure(self.parent, '''
            هذه العملية تستغرق وقتا وقد تكون بدون فائدة 
            تابع إن كنت متأكدا من وجود قصائد غير منظمة ؟
            ''' )
        if msg == Gtk.ResponseType.NO:
            return
        label = Gtk.Label()
        ls_poem = self.db.poems_0_langer()
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            langer = daw_tools.longer_half(text_poem, label, daw_tools.is_machtor(text_poem))[0]
            self.db.repair_langer(a[0], langer)
            self.progress_langer.set_fraction(n)
        self.set_sensitive(True)
        self.progress_langer.set_fraction(0.0)
        daw_customs.info(self.parent, 'تم الأمر بنجاح')
    
    def modify_rawi(self, *a):
        ls_poem = self.db.poems_no_rawi()
        if len(ls_poem) == 0: 
            daw_customs.info(self.parent, 'لا يوجد قصائد رويها غير معروف')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            rawi = daw_tools.get_int_rawi(daw_tools.rawi_poem(text_poem))
            self.db.repair_rawi(a[0], rawi)
            self.progress_rawi.set_fraction(n)
        self.set_sensitive(True)
        self.progress_rawi.set_fraction(0.0)
        
    def modify_kafia(self, *a):
        ls_poem = self.db.poems_no_kafia()
        if len(ls_poem) == 0: 
            daw_customs.info(self.parent, 'لا يوجد قصائد قافيتها غير معروفة')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            kafia = daw_tools.kafia_poem(text_poem)
            self.db.repair_kafia(a[0], kafia)
            self.progress_kafia.set_fraction(n)
        self.set_sensitive(True)
        self.progress_kafia.set_fraction(0.0)
        
    def modify_abiat(self, *a):
        ls_poem = self.db.poems_0_abiat()
        if len(ls_poem) == 0: 
            daw_customs.info(self.parent, 'لا يوجد قصائد عدد أبياتها غير معروف')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            print s
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            if daw_tools.is_machtor(text_poem):
                abiat = daw_tools.my_split(text_poem, 1)[1]
            else:
                abiat = daw_tools.my_split(text_poem, 0)[1]
            self.db.repair_abiat(a[0], abiat)
            self.progress_abiat.set_fraction(n)
        self.set_sensitive(True)
        self.progress_abiat.set_fraction(0.0)
        
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        Gtk.Notebook.__init__(self)
        self.set_border_width(7)
        
        # a --------------------------------------------
        vb1 = Gtk.VBox(False, 7)
        vb1.set_border_width(7)
        hb = Gtk.HBox(False, 3)
        modif_langer = daw_customs.ButtonClass('إصلاح التنظيم')
        modif_langer.set_tooltip_text('إصلاح القصائد التي تظهر غير مستوية الأشطار')
        modif_langer.connect('clicked',self.modify_langer)
        self.progress_langer = Gtk.ProgressBar()
        hb.pack_start(modif_langer, False, False, 0)
        hb.pack_start(self.progress_langer, True, True, 0)
        vb1.pack_start(hb, False, False, 0)
        
        hb = Gtk.HBox(False, 3)
        modif_rawi = daw_customs.ButtonClass('إصلاح الروي')
        modif_rawi.set_tooltip_text('إصلاح حرف الروي في جميع القصائد غير المعروف رويها')
        modif_rawi.connect('clicked',self.modify_rawi)
        self.progress_rawi = Gtk.ProgressBar()
        hb.pack_start(modif_rawi, False, False, 0)
        hb.pack_start(self.progress_rawi, True, True, 0)
        vb1.pack_start(hb, False, False, 0)
        
        hb = Gtk.HBox(False, 3)
        modif_kafia = daw_customs.ButtonClass('إصلاح القافية')
        modif_kafia.set_tooltip_text('إصلاح القافية في جميع القصائد غير المعروف قافيتها')
        modif_kafia.connect('clicked',self.modify_kafia)
        self.progress_kafia = Gtk.ProgressBar()
        hb.pack_start(modif_kafia, False, False, 0)
        hb.pack_start(self.progress_kafia, True, True, 0)
        vb1.pack_start(hb, False, False, 0)
        
        hb = Gtk.HBox(False, 3)
        modif_abiat = daw_customs.ButtonClass('إصلاح عدد الأبيات')
        modif_abiat.set_tooltip_text('إصلاح عدد الأبيات في جميع القصائد غير المعروف عدد أبياتها')
        modif_abiat.connect('clicked',self.modify_abiat)
        self.progress_abiat = Gtk.ProgressBar()
        hb.pack_start(modif_abiat, False, False, 0)
        hb.pack_start(self.progress_abiat, True, True, 0)
        vb1.pack_start(hb, False, False, 0)
        self.append_page(vb1, Gtk.Label("صيانة"))
        
        vbox = Gtk.Box(spacing=7,orientation=Gtk.Orientation.VERTICAL)
        vbox.set_border_width(7)
        hbox = Gtk.Box(spacing=7,orientation=Gtk.Orientation.HORIZONTAL)
        box = Gtk.Box(spacing=7,orientation=Gtk.Orientation.VERTICAL)
        self.list_ages = daw_tools.age_poet
        self.list_ages_btn = []
        for a in self.list_ages:
            btn = Gtk.CheckButton(a[1])
            btn.set_name(str(a[0]))
            box.pack_start(btn, False, False, 0)
            self.list_ages_btn.append(btn)
        frame = Gtk.Frame()
        frame.set_label('الدواوين حسب العصور')
        box.set_border_width(6)
        frame.add(box)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        remove_all = daw_customs.ButtonClass("مسح")
        remove_all.connect('clicked', self.remove_cb)
        hb.pack_start(remove_all, False, False, 0)
        vbox.pack_start(hbox, True, True, 0)
        hbox.pack_start(frame, True, True, 0)
        box = Gtk.Box(spacing=7,orientation=Gtk.Orientation.VERTICAL)
        frame = Gtk.Frame()
        frame.set_label('متفرقات')
        box.set_border_width(6)
        frame.add(box)
        self.del_favory = Gtk.CheckButton('القصائد المفضلة')
        box.pack_start(self.del_favory, False, False, 0)
        self.del_recite = Gtk.CheckButton('القصائد المسجلة')
        box.pack_start(self.del_recite, False, False, 0)
        self.del_abiaty = Gtk.CheckButton('أبياتي المفضلة')
        box.pack_start(self.del_abiaty, False, False, 0)
        self.del_search = Gtk.CheckButton('البحوث المحفوظة')
        box.pack_start(self.del_search, False, False, 0)
        self.del_mark = Gtk.CheckButton('المواضع المحفوظة')
        box.pack_start(self.del_mark, False, False, 0)
        hbox.pack_start(frame, True, True, 0)
        vbox.pack_start(hb, False, False, 0)
        self.append_page(vbox, Gtk.Label("حذف"))
#        self.show_all()